package com.company.defaultroles.security;

import com.company.defaultroles.entity.Customer;
import io.jmix.security.model.EntityAttributePolicyAction;
import io.jmix.security.model.EntityPolicyAction;
import io.jmix.security.role.annotation.EntityAttributePolicy;
import io.jmix.security.role.annotation.EntityPolicy;
import io.jmix.security.role.annotation.ResourceRole;
import io.jmix.securityui.role.annotation.MenuPolicy;
import io.jmix.securityui.role.annotation.ScreenPolicy;

@ResourceRole(name = "CustomerRole", code = CustomerRole.CODE)
public interface CustomerRole {

    String CODE = "customer-role";

    @MenuPolicy(menuIds = "Customer.browse")
    @ScreenPolicy(screenIds = {"Customer.browse", "Customer.edit"})
    void screens();

    @EntityAttributePolicy(entityClass = Customer.class, attributes = "*", action = EntityAttributePolicyAction.MODIFY)
    @EntityPolicy(entityClass = Customer.class, actions = EntityPolicyAction.ALL)
    void customer();
}